/* Sistemas Integrados TECNISA

Nome: 5031_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   22/06/2012 - Marcelo Alexsandro

Tabela MENSAGEMREGFISC: Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela MENSAGEMREGFISC
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_MENSAGEMREGFISC' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_MENSAGEMREGFISC
GO

CREATE TRIGGER LOG_FIS_MENSAGEMREGFISC
ON MENSAGEMREGFISC
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_CDREGRAFISC_OLD     VARCHAR(10)
   DECLARE @V_NRMENSREGRAFISC_OLD VARCHAR(10)
   DECLARE @V_DSMENSREGRAFISC_OLD VARCHAR(150)

   DECLARE @V_CDREGRAFISC_NEW     VARCHAR(10)
   DECLARE @V_NRMENSREGRAFISC_NEW VARCHAR(10)
   DECLARE @V_DSMENSREGRAFISC_NEW VARCHAR(150)

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.NRMENSREGRAFISC,
     DELETED.DSMENSREGRAFISC,
     NULL,
     NULL,
     NULL
   FROM
     DELETED
   WHERE
     CDREGRAFISC+NRMENSREGRAFISC NOT IN (SELECT CDREGRAFISC+NRMENSREGRAFISC FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.NRMENSREGRAFISC,
     DELETED.DSMENSREGRAFISC,
     INSERTED.CDREGRAFISC,
     INSERTED.NRMENSREGRAFISC,
     INSERTED.DSMENSREGRAFISC
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDREGRAFISC = DELETED.CDREGRAFISC
     AND INSERTED.NRMENSREGRAFISC = DELETED.NRMENSREGRAFISC

   UNION ALL

   SELECT
     'I' IDCOMANDO,
     NULL,
     NULL,
     NULL,
     INSERTED.CDREGRAFISC,
     INSERTED.NRMENSREGRAFISC,
     INSERTED.DSMENSREGRAFISC
   FROM INSERTED
   WHERE CDREGRAFISC+NRMENSREGRAFISC NOT IN (SELECT CDREGRAFISC+NRMENSREGRAFISC FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDREGRAFISC_OLD,
                                 @V_NRMENSREGRAFISC_OLD,
                                 @V_DSMENSREGRAFISC_OLD,
                                 @V_CDREGRAFISC_NEW,
                                 @V_NRMENSREGRAFISC_NEW,
                                 @V_DSMENSREGRAFISC_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SET @V_DESC   = 'Mensagem = ' + @V_DSMENSREGRAFISC_NEW;
         SET @V_ITPESQ = @V_CDREGRAFISC_NEW+CONVERT(VARCHAR,@V_NRMENSREGRAFISC_NEW);
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            SET @V_DESC   = 'Mensagem = ' + @V_DSMENSREGRAFISC_NEW;
            SET @V_ITPESQ = @V_CDREGRAFISC_NEW+CONVERT(VARCHAR,@V_NRMENSREGRAFISC_NEW);
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               SET @V_DESC   = 'Mensagem = ' + @V_DSMENSREGRAFISC_OLD;
               SET @V_ITPESQ = @V_CDREGRAFISC_OLD+CONVERT(VARCHAR,@V_NRMENSREGRAFISC_OLD);
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;
      INSERT INTO LOGREGRAFISCAL
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM)
       VALUES
         ('MENSAGEMREGFISC',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ);
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDREGRAFISC_OLD,
                                    @V_NRMENSREGRAFISC_OLD,
                                    @V_DSMENSREGRAFISC_OLD,
                                    @V_CDREGRAFISC_NEW,
                                    @V_NRMENSREGRAFISC_NEW,
                                    @V_DSMENSREGRAFISC_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_MENSAGEMREGFISC','5.30.xxx';
GO
